﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Resources;
using System.Reflection;
using ReaderB;
using System.IO.Ports;
using System.IO;

namespace DL8220new
{
    public partial class Form1 : Form
    {
        private byte ControllerAdr = 0xff;
        private int fCmdRet = 30;
        private bool IsGetting;         //是否正在执行'C'命令标志,
        private bool IsCloseApp;
        private string LastMessage;      //存储上次信息,用于比较与本次获得的信息比较,
        private int PortHandle = -1;
        private byte FreeSpaceRate;
        private byte fModel;
        private const byte OK = 0x00;
        private const byte BackGroundDataErr = 0x05;
        private const byte ControlerInitializing = 0x06;
        private const byte IndexOutOfRange = 0x07;
        private const byte FindConfigDataError = 0x08;
        private const byte Mode = 0x09;
        private const byte GetRecordTimeError = 0x0A;
        private const byte ConstraintSetEAS = 0x0B;
        private const byte SaveNewIRError = 0x0C;
        private const byte ISWritting = 0x0D;
        private const byte ErrorMessage = 0xFF;
        private const byte FindingConfigData = 0x0F;
        private const byte CommunicationErr = 0x30;
        private const byte RetCRCErr = 0x31;
        private const byte RetDataErr = 0x32; //返回数据长度有误
        private const byte CommunicationBusy = 0x33;
        const  string AlarmStr = "A55AAA55";
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] sp;
            int i;
            ComboBox_Port.Items.Add("Auto");
            sp = SerialPort.GetPortNames();
            for (i = 0; i < sp.Length; i++)
            {
                ComboBox_Port.Items.Add(sp[i]);
            }
            InitiComboBox();
            InitiButton();
            PortHandle = -1;
            IsGetting = false;
            IsCloseApp = false;
        }
        private void InitiComboBox()
        {
            ComboBox_Port.SelectedIndex = 0;

            ComboBox2.SelectedIndex = 1;
            ComboBox3.SelectedIndex = 1;
            ComboBox5.SelectedIndex = 1;
            ComboBox6.SelectedIndex = 1;
            ComboBox7.SelectedIndex = 1;
            ComboBox8.SelectedIndex = 1;

            RadioButton_Red.Checked = true;
            RadioButton6.Checked = true;
            RadioButton8.Checked = true;

        }
        private void InitiButton()
        {
            OpenPort.Enabled = true;
            ClosePort.Enabled = false;
            CloseIR.Enabled = false;
            OpenIR.Enabled = false;
            Btn_GetIRStatus.Enabled = false;
            LEDAndBuzTest.Enabled = false;
            SetMode.Enabled = false;
            GetMode.Enabled = false;
            Button1.Enabled = false;
            Button2.Enabled = false;
            IF1Start.Enabled = false;
            button4.Enabled = false;
        }
        private void ClosePort_Click(object sender, EventArgs e)
        {
            StaticClassReaderB.CloseComPort();
            InitiButton();
            PortHandle = -1;
            StatusBar1.Panels[0].Text = " ";
            StatusBar1.Panels[1].Text = " ";
        }

        private void OpenPort_Click(object sender, EventArgs e)
        {
            String temp = "";
            int portNum = -1;
            try
            {
                OpenPort.Enabled = false;
                if (ControlAddr.Text == "")
                {
                    MessageBox.Show("Please input the address to open the controller", "Information");
                    return;
                }
                ControllerAdr = Convert.ToByte(ControlAddr.Text, 16);
                Cursor = Cursors.WaitCursor;
                if (ComboBox_Port.SelectedIndex == 0)
                    fCmdRet = StaticClassReaderB.AutoOpenComPort(ref portNum, ref  ControllerAdr, ref  PortHandle);
                else
                {
                    temp = ComboBox_Port.SelectedItem.ToString();
                    portNum = Convert.ToByte(temp.Substring(3, temp.Length - 3));
                    fCmdRet = StaticClassReaderB.OpenComPort(portNum, ref ControllerAdr, ref PortHandle);
                }
                if (fCmdRet == 0)
                {
                    StatusBar1.Panels[2].Text = "IF1:COM" + portNum.ToString();
                    EnableButton();
                    if (StaticClassReaderB.ModeSwitch(ref ControllerAdr, ref fModel, ref FreeSpaceRate, PortHandle) == 0)
                    {
                        if (fModel == 0)
                            IF1Start.Enabled = true;
                        button4.Enabled = false;
                    }
                }
                else
                    MessageBox.Show("OpenComPort failed", "Communication");
            }
            finally
            {
                AddCmdLog("OpenComPort", "OpenComPort", fCmdRet);
                OpenPort.Enabled = false;
                Cursor = Cursors.Default;
            }
        }
        private void EnableButton()
        {
            OpenPort.Enabled = false;
            ClosePort.Enabled = true;
            CloseIR.Enabled = true;
            OpenIR.Enabled = true;
            Btn_GetIRStatus.Enabled = true;
            LEDAndBuzTest.Enabled = true;
            SetMode.Enabled = true;
            GetMode.Enabled = true;
            Button1.Enabled = true;
            Button2.Enabled = true;
            IF1Start.Enabled = true;
            button4.Enabled = false;
        }
        private void AddCmdLog(string CMD, string cmdStr, int cmdRet)
        {
            try
            {
                StatusBar1.Panels[0].Text = "";
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + cmdStr + ": " + GetReturnCodeDesc(cmdRet);
            }
            finally
            {
                ;
            }
        }
        private string GetReturnCodeDesc(int cmdRet)
        {
            switch (cmdRet)
            {
                case OK:
                    return "Operation Successed";
                case Mode:
                    return "Mode error";
                case ISWritting:
                    return "Can not set stop record";
                case CommunicationErr:
                    return "Communication error";
                case FindConfigDataError:
                    return "Invalid Command";
                case IndexOutOfRange:
                    return "Search out of range";
                case FindingConfigData:
                    return "Are looking for information....";
                case RetCRCErr:
                    return "CRC Check error";
                case GetRecordTimeError:
                    return "Can not save New mode";
                case ControlerInitializing:
                    return "Ongoing internal self-test....";
                case RetDataErr:
                    return "Return data length error";
                case BackGroundDataErr:
                    return "Record not exist or has expired";
                case CommunicationBusy:
                    return "Communication Busy";
                case ConstraintSetEAS:
                    return "Be forced in EAS mode";
                case SaveNewIRError:
                    return "New direction Saved Failed";
                default:
                    return "";
            }
        }
        private void LEDAndBuzTest_Click(object sender, EventArgs e)
        {
            byte BuzActTime;
            byte BuzQuiteTime;
            byte BuzzerActTimes;
            byte LEDOnTime;
            byte LEDOffTime;
            byte LEDFlickerTimes;
            byte LEDColor;
            BuzActTime = Convert.ToByte(ComboBox7.SelectedIndex);
            BuzQuiteTime = Convert.ToByte(ComboBox6.SelectedIndex);
            BuzzerActTimes = Convert.ToByte(ComboBox8.SelectedIndex);
            LEDOnTime = Convert.ToByte(ComboBox2.SelectedIndex);
            LEDOffTime = Convert.ToByte(ComboBox3.SelectedIndex);
            LEDFlickerTimes = Convert.ToByte(ComboBox5.SelectedIndex);
            if (RadioButton_Red.Checked)
            {
                LEDColor = 0;
            }
            else
            {
                LEDColor = 1;
            }
            fCmdRet = StaticClassReaderB.BuzzerAndLEDControl(ref ControllerAdr, BuzActTime, BuzQuiteTime, BuzzerActTimes, LEDOnTime, LEDOffTime, LEDFlickerTimes, LEDColor, ref FreeSpaceRate, PortHandle);
            AddCmdLog("B", "Test", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
        }

        private void CloseIR_Click(object sender, EventArgs e)
        {
            byte CloseIR = 0x01;
            fCmdRet = StaticClassReaderB.SetIR(ref ControllerAdr, CloseIR, ref FreeSpaceRate, PortHandle);
            AddCmdLog("I", "Close", fCmdRet);
            StatusBar1.Panels[1].Text = " ";

        }

        private void OpenIR_Click(object sender, EventArgs e)
        {

            byte CloseIR = 0x02;
            fCmdRet = StaticClassReaderB.SetIR(ref ControllerAdr, CloseIR, ref FreeSpaceRate, PortHandle);
            AddCmdLog("I", "Active", fCmdRet);
            StatusBar1.Panels[1].Text = " ";

        }

        private void Btn_GetIRStatus_Click(object sender, EventArgs e)
        {
            byte IRStatuas = 0;
            fCmdRet = StaticClassReaderB.GetIRStatus(ref ControllerAdr, ref IRStatuas, ref  FreeSpaceRate, PortHandle);
            if (IRStatuas == 1)
                TextBox4.Text = "Active";
            if (IRStatuas == 0)
                TextBox4.Text = "Closed";
            AddCmdLog("I", "Query", fCmdRet);
            StatusBar1.Panels[1].Text = " ";

        }

        private void Button1_Click(object sender, EventArgs e)
        {
            byte model = 0;
            if (RadioButton8.Checked)
                model = 0x80;
            if (RadioButton9.Checked)
                model = 0x81;
            fCmdRet = StaticClassReaderB.IRDirectionSetting(ref ControllerAdr, ref model, ref FreeSpaceRate, PortHandle);
            AddCmdLog("N", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";

        }

        private void Button2_Click(object sender, EventArgs e)
        {
            byte model = 0;
            fCmdRet = StaticClassReaderB.IRDirectionSetting(ref ControllerAdr, ref model, ref FreeSpaceRate, PortHandle);
            if (fCmdRet != 0)
            {
                AddCmdLog("B", "Get", fCmdRet);
                return;
            }
            if (model == 0)
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Normal infrared sensor sequence";
            if (model == 1)
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Reversed infrared sensor sequence";
        }

        private void SetMode_Click(object sender, EventArgs e)
        {
            fModel = 0x00;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr, ref fModel, ref FreeSpaceRate, PortHandle);
            if ((fModel & 0x02) == 0x02)
            {
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Be forced in EAS mode";
                return;
            }
            if (RadioButton6.Checked)
                fModel = 0x80;
            if (RadioButton7.Checked)
                fModel = 0x81;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr, ref fModel, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
            {
                if (fModel == 0)
                {
                    IF1Start.Enabled = true;
                    button4.Enabled = false;
                }
            }
            AddCmdLog("M", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
        }

        private void GetMode_Click(object sender, EventArgs e)
        {
            fModel = 0x00;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr, ref fModel, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
            {
                if (fModel == 0)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Channel Mode";
                if (fModel == 1)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "EAS Mode";
                if ((fModel & 0x02) == 0x02)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Be forced in EAS Mode";
                StatusBar1.Panels[1].Text = "";
            }
            else
                AddCmdLog("M", "Get", fCmdRet);
        }

        private void IF1Start_Click(object sender, EventArgs e)
        {
            IF1Start.Enabled = false;
            button4.Enabled = true;
            timer1.Enabled = true;
            IsCloseApp = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            IF1Start.Enabled = true;
            button4.Enabled = false;
            timer1.Enabled = false;
            IsCloseApp = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (IsGetting) //是否正在执行() 'C'命令
                return;
            if (IsCloseApp) this.Close();

            string UID;
            byte MsgLength, MsgType;
            byte[] Msg = new byte[46];
            IsGetting = true;  //进入该过程时将正在执行标志置
            MsgLength = 0;
            MsgType = 0;
            fCmdRet = StaticClassReaderB.GetChannelMessage(ref ControllerAdr, Msg, ref MsgLength, ref MsgType, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
            {
                UID = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
              //  UID1 = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[7], 16).PadLeft(2, '0');


                UID = UID.ToUpper();
                //UID1 = UID1.ToUpper();
                //InFlag = Convert.ToByte(Msg[8]);
                if (string.IsNullOrEmpty(UID)) return;
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                Getdata(UID);
            }
            IsGetting = false;
        }
        private void Getdata(string UID1)
        {
            byte StartBlock = 0, BlockCount = 0, BlockLen; //'起始块号,块数量,每个数据块长度
            int i;
            byte[] UID = new byte[8];
            byte[] TagData = new byte[1024];
            string data = null;
            StartBlock = 0;
            BlockCount = 1;
            BlockLen = 4;
            if (UID1.Length == 16)
                UID = HexStringToByteArray(UID1);
            else //UID Data Error
            {
                return;
            }
            fCmdRet = StaticClassReaderB.ReadTagData(ref ControllerAdr, UID, StartBlock, BlockCount, BlockLen, TagData, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
            {
                string temp = ByteArrayToHexString(TagData).Replace(" ", "");
                for (i = StartBlock; i <= StartBlock + BlockCount - 1; i++)
                {
                    data = temp.Substring((i - StartBlock) * 10 + 2, 8);
                    if (data.ToUpper() == AlarmStr)
                    {
                        ListViewItem item=new ListViewItem ();

                        item.SubItems[0].Text  = DateTime.Now.ToString();
                        item.SubItems.Add(UID1);
                        ListView1.Items.Add(item); 
                        ListView1.EnsureVisible(ListView1.Items.Count - 1);
                        LEDAndBuzTest_Click(null, null);
                    }
                }
            }
            StatusBar1.Panels[1].Text = " ";
        }
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
    }
}
