﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32; //注册表操作
using ReaderA;

namespace SetTag
{
    public partial class Form1 : Form
    {
        public static int portIndex = -1;
        public static byte readerAddr = 0xff;
        const string AlarmStr = "A55AAA55";
        string DSFIDAndUIDList;           //存储从开始询查到接收到0E之间的所有DSFID,UID 
        int TotalCardNumber = 0;
        string[] CardNo = new string [1];     //读取到的卡号列表
        bool Closeing = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GetSerialPort();
            if (Comname.Items.Count > 0)
            {
                Comname.SelectedIndex = 0;
            }
            else
            {
                btnOpenComPort.Enabled = false;
            }
        }
        private void GetSerialPort() //获取串口列表   
        {
            Comname.Items.Clear();
            RegistryKey keyCom = Registry.LocalMachine.OpenSubKey("Hardware\\DeviceMap\\SerialComm");
            if (keyCom != null)
            {
                string[] sSubKeys = keyCom.GetValueNames();
                foreach (string sName in sSubKeys)
                {
                    string sValue = (string)keyCom.GetValue(sName);
                    Comname.Items.Add(sValue);
                }
                if (Comname.Items.Count > 0) { Comname.SelectedIndex = 0; }
            }
        }
        private void btnOpenComPort_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            int n = 0;
            Opencom(Comname.Text, "FF", ref n);
            this.Cursor = Cursors.Default;
        }
        private void Opencom(string Com, string Addr, ref int baud)
        {
            int portNum = -1;
            int fCmdRet = 0x30;
            byte fbaud = 0;
            try
            {
                if (Addr == "") { Addr = "FF"; }
                readerAddr = Convert.ToByte(Addr, 16);
                portNum = int.Parse(Com.Substring(3));
                for (int n = 3; n >= 0; n--)
                {
                    fbaud = Convert.ToByte(n);
                    fCmdRet = StaticClassReaderA.OpenComPort(portNum, ref readerAddr, fbaud, ref portIndex);
                    if (fCmdRet == 0)
                    {
                        baud = n;
                        fCmdRet = StaticClassReaderA.OpenRf(ref readerAddr, portIndex);       //打开串口成功时打开射频
                        if (fCmdRet == 0)
                        {
                            btnOpenComPort.Enabled = false;
                            button5.Enabled = true;
                            panel1.Enabled = true;
                            return;
                        }
                        else
                        {
                            closecom();
                        }
                    }
                }

            }
            catch { }
            MessageBox.Show("OpenComPort failed", "Communication", MessageBoxButtons.OK, MessageBoxIcon.Stop);
        }
        private void closecom()
        {
            int fCmdRet = 0x30;
            fCmdRet = StaticClassReaderA.CloseSpecComPort(portIndex);
            if (fCmdRet == 0)
            {
                btnOpenComPort.Enabled = true;
                button5.Enabled = false;
                panel1.Enabled = false;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Button button = (Button)sender;
            string tagdata = button.Tag.ToString() == "0" ? AlarmStr : "00000000";
            label1.Visible = false;
            label3.Visible = false; 
            if (NowRead())
            {
                if (writetotag(tagdata, 0, CardNo[0]))
                {
                    label1.Text = "Successed";
                }
                else
                {
                    label1.Text = "Failed";
                }
            }
            else
            {
                label1.Text = "no tags";
            }
            label1.Visible = true;

        }
        public bool  NowRead()
        {
            int i, fCmdRet = 0x30;
            byte state = 6;             //默认不带AFI的InventoryScan
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[2300];
            byte cardNumber = 0;

            fCmdRet = StaticClassReaderA.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portIndex);
            if (fCmdRet == 0x0B || fCmdRet == 0x0E) //((fCmdRet == 0x0A)  || 
            {
                if (fCmdRet == 0x0E)
                {
                    Array.Resize(ref DSFIDAndUID, cardNumber * 9);
                    DSFIDAndUIDList = ByteArrayToHexString(DSFIDAndUID).Replace(" ", "");
                    TotalCardNumber = (byte)(DSFIDAndUIDList.Length / 18);    //收到的总数
                    if (fCmdRet == 0x0E && TotalCardNumber > 0)
                    {
                        Array.Resize(ref CardNo, TotalCardNumber);        //重新定义数组大小(维数)
                        for (i = 0; i < TotalCardNumber; i++)
                        {
                            CardNo[i] = DSFIDAndUIDList.Substring(18 * i + 2, 16);
                        }
                        marktxt.Text = CardNo.Length.ToString();
                        return true;
                    }
                }
                if (fCmdRet == 0x0B)
                {
                    NowRead();
                }
            }
            return false;

        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        private bool writetotag(string tagdata, byte address,string cardno)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] data = new byte[4];
            data = HexStringToByteArray(tagdata);
            UID = HexStringToByteArray(cardno);
            state = 8;
            fCmdRet = StaticClassReaderA.WriteSingleBlock(ref readerAddr,ref state, UID, address, data, ref errorCode, portIndex);
            return fCmdRet == 0;
        }
        public static byte[] HexStringToByteArray(string s)
        {
            byte[] buffer = new byte[s.Length / 2];
            try
            {
                s = s.Replace(" ", "");
                for (int i = 0; i < s.Length; i += 2)
                    buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
                return buffer;
            }
            catch
            {
                return buffer;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            button1.Enabled =button2 .Enabled =  button3.Enabled = false;
            button4.Enabled = true; 
            Closeing = false;
            label3.Visible = label1.Visible = false;
            timer1.Enabled = true;
           
        }

        private void button4_Click(object sender, EventArgs e)
        {
            button4.Enabled = false;
            button1.Enabled = button2.Enabled = button3.Enabled =button3.Enabled = true;
            Closeing = true;
            timer1.Enabled = false;
            label3.Visible = label1.Visible = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (!NowRead())
            {
                label3.Visible = false;
                marktxt.Text = "0";
                return;
            }
            byte state = 0;
            byte ErrorCode = 0;
            int fCmdRet = 0x30;
            byte[] data = new byte[4];  //
            byte[] blockSecStatus = new byte[1];
            byte[] UID = HexStringToByteArray(CardNo [0]);
            fCmdRet = StaticClassReaderA.ReadMultipleBlock(ref readerAddr, ref state, UID, 0,1, blockSecStatus, data, ref ErrorCode, portIndex);
            if (fCmdRet == 0)
            {
                string tagdata = null;
                for (int tmp = 0; tmp < data.Length; tmp++)
                {
                    tagdata  = tagdata  + data[tmp].ToString("X2");      //转为16进制字符
                }
                if (tagdata == AlarmStr)
                {
                    if(Closeing ==false )  label3.Visible = true; 
                }
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            closecom();
        }
    }
}
